import java.util.Scanner;


public class Example {

	public static void main(String[] argv){
		Test hasIdentConseq = new Test() {
			
			@Override
			public boolean test(String s) {
				Scanner scanner = new Scanner(s);
				if(scanner.hasNextInt()){
					int prev = scanner.nextInt();
					while (scanner.hasNextInt()) {
						int cur = scanner.nextInt();
					    if(prev == cur) {
					    		return false;
					    }
					    prev = cur;
					}
				} 
				
				return true;
			}
		};
		String res = DDMin.ddMin(hasIdentConseq,"1 3 5 3 9 17 44 3 6 1 1 0 44 1 44 0");
		System.out.println(res);
		
		Test haslessThan2Xs = new Test() {
			
			@Override
			public boolean test(String s) {
				int nrX = 0;
				for(char c : s.toCharArray()){
					if(c == 'X') { nrX +=1; }
				}
			    return nrX < 2;
			}
		};
		res = DDMin.ddMin(haslessThan2Xs,"XAABBXC");
		System.out.println(res);
		
        Test makesMozzilaCrash = new Test() {
			
			@Override
			public boolean test(String s) {
				int i = s.indexOf("<SELECT");
				return i == - 1 || !s.substring(i).contains(">");
			}
		};
        res = DDMin.ddMin(makesMozzilaCrash,html);
        System.out.println(res);
	}
	
	
	final static String html = 
"<td align=left valign=top>\n" +
"<SELECT NAME=\"op sys\" MULTIPLE SIZE=7>\n" +
"<OPTION VALUE=\"All\">All<OPTION VALUE=\"Windows 3.1\">Windows 3.1<OPTION VALUE=\"Windows 95\">Windows 95<OPTION VALUE=\"Windows\n" +
"98\">Windows 98<OPTION VALUE=\"Windows ME\">Windows ME<OPTION VALUE=\"Windows 2000\">Windows 2000<OPTION VALUE=\"Windows\n" +
"NT\">Windows NT<OPTION VALUE=\"Mac System 7\">Mac System 7<OPTION VALUE=\"Mac System 7.5\">Mac System 7.5<OPTION VALUE=\"Mac\n" +
"System 7.6.1\">Mac System 7.6.1<OPTION VALUE=\"Mac System 8.0\">Mac System 8.0<OPTION VALUE=\"Mac System 8.5\">Mac System\n" +
"8.5<OPTION VALUE=\"Mac System 8.6\">Mac System 8.6<OPTION VALUE=\"Mac System 9.x\">Mac System 9.x<OPTION VALUE=\"MacOS X\">MacOS\n" +
"X<OPTION VALUE=\"Linux\">Linux<OPTION VALUE=\"BSDI\">BSDI<OPTION VALUE=\"FreeBSD\">FreeBSD<OPTION VALUE=\"NetBSD\">NetBSD<OPTION\n" +
"VALUE=\"OpenBSD\">OpenBSD<OPTION VALUE=\"AIX\">AIX<OPTION VALUE=\"BeOS\">BeOS<OPTION VALUE=\"HP-UX\">HP-UX<OPTION\n" +
"VALUE=\"IRIX\">IRIX<OPTION VALUE=\"Neutrino\">Neutrino<OPTION VALUE=\"OpenVMS\">OpenVMS<OPTION VALUE=\"OS/2\">OS/2<OPTION\n" +
"VALUE=\"OSF/1\">OSF/1<OPTION VALUE=\"Solaris\">Solaris<OPTION VALUE=\"SunOS\">SunOS<OPTION VALUE=\"other\">other</SELECT>\n" +
"</td>\n" +
"<td align=left valign=top>\n" +
"<SELECT NAME=\"priority\" MULTIPLE SIZE=7>\n" +
"<OPTION VALUE=\"--\">--<OPTION VALUE=\"P1\">P1<OPTION VALUE=\"P2\">P2<OPTION VALUE=\"P3\">P3<OPTION VALUE=\"P4\">P4<OPTION\n" +
"VALUE=\"P5\">P5</SELECT>\n" +
"</td>\n" +
"<td align=left valign=top>\n" +
"<SELECT NAME=\"bug severity\" MULTIPLE SIZE=7>\n" +
"<OPTION VALUE=\"blocker\">blocker<OPTION VALUE=\"critical\">critical<OPTION VALUE=\"major\">major<OPTION\n" +
"VALUE=\"normal\">normal<OPTION VALUE=\"minor\">minor<OPTION VALUE=\"trivial\">trivial<OPTION VALUE=\"enhancement\">enhancement</SELECT>\n" +
"</tr>\n" +
"</table>\n";
	
}
