import java.util.Arrays;
import java.util.Random;


public class Search {

	public static void main(String[] argv){
		System.out.println(search(new int[]{1,2}, 3));
	}
	
	
	public static int linearSearch(int[] arr, int elem){
		for(int i = 0 ; i < arr.length ; i++){
			if(arr[i] == elem){
				return i;
			}
		}
		return -1;
	}
	
	// Requires: arr is non-null and sorted in non-descreasing order
	// Ensures: result is the lowest index i such that arr[i] == elem, or -1 if
	//          no such index exists
	public static int search(int[] arr, int elem){
		int low = 0;
		int high = arr.length -1;
		while(low <= high){
			int mid = (low + high)/2;
			if(elem < arr[mid]){
				high = mid - 1;
			} else if (elem > arr[mid]){
				low = mid + 1;
			} else {
				return mid;
			}
		}
		return -1;
	}
}
